#include "listas.h"
#include <string.h>

void ordenarporlegajo(struct alumno **H) {
	int nodos;
	int i;
	int swappeada;
	struct alumno *q;
	
	// cuento cantidad de nodos
	nodos = contarnodos(H);
	
	do {
		swappeada = 0;
		// arranco al comienzo de la lista
		q = *H;
		for(i=0; i < (nodos - 1); i++) {
			// recorro todos los nodos
			if(q->legajo > q->next->legajo) {
				/* si el actual es mayor que el siguiente, marco que los 
				 * intercambie, y llamo a swapnodo
				 */
				swappeada = 1;
				swapnodo(q, q->next);
			}
			// voy al siguiente
			q = q->next;
		}
		// recorro la lista entera, hasta que no haya tenido que intercambiar
		// ningun nodo, indicando que esta ordenada.
	} while(swappeada);
}

void ordenarpornombre(struct alumno **H) {
	int nodos;
	int i;
	int swappeada;
	struct alumno *q;
	
	nodos = contarnodos(H);
	
	do {
		swappeada = 0;
		q = *H;
		for(i=0; i < (nodos - 1); i++) {
			if( strcmp(q->nombre, q->next->nombre) > 0) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
			q = q->next;
		}
	} while(swappeada);
}

void ordenarporapellido(struct alumno **H) {
	int nodos;
	int i;
	int swappeada;
	struct alumno *q;
	
	nodos = contarnodos(H);
	
	do {
		swappeada = 0;
		q = *H;
		for(i=0; i < (nodos - 1); i++) {
			if( strcmp(q->apellido, q->next->apellido) > 0) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
			q = q->next;
		}
	} while(swappeada);
}

void ordenarporemail(struct alumno **H) {
	int nodos;
	int i;
	int swappeada;
	struct alumno *q;
	
	nodos = contarnodos(H);
	
	do {
		swappeada = 0;
		q = *H;
		for(i=0; i < (nodos - 1); i++) {
			if( strcmp(q->email, q->next->email) > 0) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
			q = q->next;
		}
	} while(swappeada);
}

void ordenarpornota1p(struct alumno **H) {
	int nodos;
	int i;
	int swappeada;
	struct alumno *q;
	
	nodos = contarnodos(H);
	
	do {
		swappeada = 0;
		q = *H;
		for(i=0; i < (nodos - 1); i++) {
			if(q->nota1p > q->next->nota1p) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
			q = q->next;
		}
	} while(swappeada);
}

void ordenarpornota2p(struct alumno **H) {
	int nodos;
	int i;
	int swappeada;
	struct alumno *q;
	
	nodos = contarnodos(H);
	
	do {
		swappeada = 0;
		q = *H;
		for(i=0; i < (nodos - 1); i++) {
			if(q->nota2p > q->next->nota2p) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
			q = q->next;
		}
	} while(swappeada);
}

void ordenarpornotatp(struct alumno **H) {
	int nodos;
	int i;
	int swappeada;
	struct alumno *q;
	
	nodos = contarnodos(H);
	
	do {
		swappeada = 0;
		q = *H;
		for(i=0; i < (nodos - 1); i++) {
			if(q->notatp > q->next->notatp) {
				swappeada = 1;
				swapnodo(q, q->next);
			}
			q = q->next;
		}
	} while(swappeada);
}

